const fs = require("fs"); //File system
const imported = require("./nodes.json"); //Nodes root object
const raw = imported.nodes; //Extract nodes list
const config = require("./config.json"); //Configuration
var converted = []; //Converted nodes list, not a string
var file = ""; //String that will be written to file

//Conversion
for(i=0;i<raw.length;i++){
  if (Array.isArray(raw[i])) { //Just so we don't have any objects trying to slip through.
    var node = raw[i]; //Add node reference to make my life easier
    var working = []; //Array of properties it's working on 
    
    if (node[0]!=="id") { //Check if it's not the definition line
      working.push(`\"${node[0]}\"`); //Node name
      working.push(parseFloat((node[1]*config.scale*config.scale_x)+config.translate_x).toFixed(3)); //Converting axis
      working.push(parseFloat((node[2]*config.scale*config.scale_y)+config.translate_y).toFixed(3));
      working.push(parseFloat((node[3]*config.scale*config.scale_z)+config.translate_z).toFixed(3));
      if (node[4]) working.push(JSON.stringify(node[4])); //Extra properties
      converted.push(working); //Add converted node to array
    } else converted.push("[\"id\",\"posX\",\"posY\",\"posZ\"]"); //Add definition line to array (if it exists)
  } else converted.push(JSON.stringify(raw[i])); //Add property object to it
}

//Format all lines correctly to a string (which will be pushed to the text file)
for(i=0;i<converted.length;i++) {
  if (!Array.isArray(converted[i])) { //Check if it's a property object, instead of a node
    file = file+`\n${converted[i]},`; //String concatenation, .concat() wouldn't work with me
  } else file = file+`\n[${converted[i]}],`; //String concatenation with the correct format
}

//Write to file
fs.writeFile("./exported_file/converted.txt", file, function (err) { //Initiate write to file
  if (err) return console.log(`Unable to convert successfully:\n${err}`); //In case of any error, just for debugging. No other error handling lol
  console.log(`Node positions converted with ${converted.length} entries.`); //Output message in console so you know it's done
});